import { world } from "@minecraft/server";

/** @type {import("@minecraft/server").BlockCustomComponent} */
const CustomTrapdoorBlockComponent = {
    onPlayerInteract({ block, dimension }) {
        const isOpen = block.permutation.getState("wiki:open");
        const sound = isOpen ? "close.iron_trapdoor" : "open.iron_trapdoor";

        block.setPermutation(block.permutation.withState("wiki:open", !isOpen));

        dimension.playSound(sound, block.center(), {
            pitch: 0.9,
            volume: 0.9,
        });
    },
};

world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry }) => {
    blockComponentRegistry.registerCustomComponent(
        "wiki:custom_trapdoor",
        CustomTrapdoorBlockComponent
    );
});